"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide6.QtCore, except for defaults which are replaced by "...".
"""
from __future__ import annotations

from enum import IntFlag

import PySide6.QtCore

class QLibraryInfo:
    """
    https://doc.qt.io/qt-6/qlibraryinfo.html

    **Detailed Description**

    Many pieces of information are established when Qt is configured and built.
    This class provides an abstraction for accessing that information. By using
    the static functions of this class, an application can obtain information
    about the instance of the Qt library which the application is using at run-
    time.

    You can also use a `qt.conf` file to override the hard-coded paths that are
    compiled into the Qt library. For more information, see the **Using
    qt.conf**  documentation.

    **See also** **QSysInfo**  and **Using qt.conf** .
    """

    PrefixPath: QLibraryInfo.LibraryPath = ...
    DocumentationPath: QLibraryInfo.LibraryPath = ...
    HeadersPath: QLibraryInfo.LibraryPath = ...
    LibrariesPath: QLibraryInfo.LibraryPath = ...
    LibraryExecutablesPath: QLibraryInfo.LibraryPath = ...
    BinariesPath: QLibraryInfo.LibraryPath = ...
    PluginsPath: QLibraryInfo.LibraryPath = ...
    Qml2ImportsPath: QLibraryInfo.LibraryPath = ...
    QmlImportsPath: QLibraryInfo.LibraryPath = ...
    ArchDataPath: QLibraryInfo.LibraryPath = ...
    DataPath: QLibraryInfo.LibraryPath = ...
    TranslationsPath: QLibraryInfo.LibraryPath = ...
    ExamplesPath: QLibraryInfo.LibraryPath = ...
    TestsPath: QLibraryInfo.LibraryPath = ...
    SettingsPath: QLibraryInfo.LibraryPath = ...

    class LibraryPath(IntFlag):
        PrefixPath: QLibraryInfo.LibraryPath = ...
        DocumentationPath: QLibraryInfo.LibraryPath = ...
        HeadersPath: QLibraryInfo.LibraryPath = ...
        LibrariesPath: QLibraryInfo.LibraryPath = ...
        LibraryExecutablesPath: QLibraryInfo.LibraryPath = ...
        BinariesPath: QLibraryInfo.LibraryPath = ...
        PluginsPath: QLibraryInfo.LibraryPath = ...
        Qml2ImportsPath: QLibraryInfo.LibraryPath = ...
        QmlImportsPath: QLibraryInfo.LibraryPath = ...
        ArchDataPath: QLibraryInfo.LibraryPath = ...
        DataPath: QLibraryInfo.LibraryPath = ...
        TranslationsPath: QLibraryInfo.LibraryPath = ...
        ExamplesPath: QLibraryInfo.LibraryPath = ...
        TestsPath: QLibraryInfo.LibraryPath = ...
        SettingsPath: QLibraryInfo.LibraryPath = ...
    @staticmethod
    def build() -> bytes: ...
    @staticmethod
    def isDebugBuild() -> bool:
        """
        https://doc.qt.io/qt-6/qlibraryinfo.html#isDebugBuild

        **[static, since 5.0] bool QLibraryInfo::isDebugBuild()**

        Returns `true` if this build of Qt was built with debugging enabled, or
        false if it was built in release mode.

        This function was introduced in Qt 5.0.
        """
        ...
    @staticmethod
    def location(location: PySide6.QtCore.QLibraryInfo.LibraryPath) -> str: ...
    @staticmethod
    def path(p: PySide6.QtCore.QLibraryInfo.LibraryPath) -> str:
        """
        https://doc.qt.io/qt-6/qlibraryinfo.html#path

        **[static, since 6.0] QString
        QLibraryInfo::path(QLibraryInfo::LibraryPath p )**

        Returns the path specified by **p**.

        This function was introduced in Qt 6.0.
        """
        ...
    @staticmethod
    def platformPluginArguments(platformName: str) -> list[str]: ...
    @staticmethod
    def version() -> PySide6.QtCore.QVersionNumber:
        """
        https://doc.qt.io/qt-6/qlibraryinfo.html#version

        **[static, since 5.8] QVersionNumber QLibraryInfo::version()**

        Returns the version of the Qt library.

        This function was introduced in Qt 5.8.

        **See also** **qVersion** ().
        """
        ...
