"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide6.QtDataVisualization, except for defaults which are replaced by "...".
"""

from __future__ import annotations

import PySide6.QtCore
import PySide6.QtDataVisualization
import PySide6.QtGui

class Q3DLight(PySide6.QtDataVisualization.Q3DObject):
    """
    https://doc.qt.io/qt-6/q3dlight.html

    **Detailed Description**

    Q3DLight represents a monochrome light source in 3D space.

    **Note:** Default light has **isAutoPosition** () `true`.
    """

    def __init__(self, parent: PySide6.QtCore.QObject | None = ...) -> None:
        """
        https://doc.qt.io/qt-6/q3dlight.html#Q3DLight

        **Q3DLight::Q3DLight(QObject * parent = nullptr)**

        Constructs a new 3D light located at origin. An optional **parent**
        parameter can be given and is then passed to **QObject**  constructor.
        """
        ...
    def isAutoPosition(self) -> bool: ...
    def setAutoPosition(self, enabled: bool) -> None:
        """
        https://doc.qt.io/qt-6/q3dlight.html#autoPosition-prop

        **[since QtDataVisualization 5.9] autoPosition : bool**

        This property holds whether the light position follows the camera
        automatically.

        **Note:** Has no effect if shadows are enabled. Remember to disable
        shadows before setting light's position, or it will be overwritten by
        automatic positioning if `isAutoPosition()` is `false`.

        This property was introduced in QtDataVisualization 5.9.

        **Access functions:**

        bool **isAutoPosition** ()
        void **setAutoPosition** (bool **enabled**
        )

        **Notifier signal:**

        void **autoPositionChanged** (bool **autoPosition** )

        **Member Function Documentation**
        """
        ...
    @property
    def autoPositionChanged(self) -> PySide6.QtCore.SignalInstance: ...
