"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide6.QtGui, except for defaults which are replaced by "...".
"""
from __future__ import annotations

from typing import overload

import PySide6.QtCore
import PySide6.QtGui

class QDragEnterEvent(PySide6.QtGui.QDragMoveEvent):
    """
    https://doc.qt.io/qt-6/qdragenterevent.html

    **Detailed Description**

    A widget must accept this event in order to receive the **drag move events**
    that are sent while the drag and drop action is in progress. The drag enter
    event is always immediately followed by a drag move event.

    QDragEnterEvent inherits most of its functionality from **QDragMoveEvent** ,
    which in turn inherits most of its functionality from **QDropEvent** .

    **See also** **QDragLeaveEvent** , **QDragMoveEvent** , and **QDropEvent** .
    """

    @overload
    def __init__(self, arg__1: PySide6.QtGui.QDragEnterEvent) -> None:
        """
        https://doc.qt.io/qt-6/qdragenterevent.html#QDragEnterEvent-2

        **QDragEnterEvent::QDragEnterEvent(const QPoint & point ,
        Qt::DropActions actions , const QMimeData * data , Qt::MouseButtons
        buttons , Qt::KeyboardModifiers modifiers )**

        Constructs a QDragEnterEvent that represents a drag entering a widget at
        the given **point** with mouse and keyboard states specified by
        **buttons** and **modifiers**.

        The drag data is passed as MIME-encoded information in **data** , and
        the specified **actions** describe the possible types of drag and drop
        operation that can be performed.

        **Warning:** Do not create a QDragEnterEvent yourself since these
        objects rely on Qt's internal state.
        """
        ...
    @overload
    def __init__(
        self,
        pos: PySide6.QtCore.QPoint,
        actions: PySide6.QtCore.Qt.DropActions,
        data: PySide6.QtCore.QMimeData,
        buttons: PySide6.QtCore.Qt.MouseButtons,
        modifiers: PySide6.QtCore.Qt.KeyboardModifiers,
    ) -> None:
        """
        https://doc.qt.io/qt-6/qdragenterevent.html#QDragEnterEvent-2

        **QDragEnterEvent::QDragEnterEvent(const QPoint & point ,
        Qt::DropActions actions , const QMimeData * data , Qt::MouseButtons
        buttons , Qt::KeyboardModifiers modifiers )**

        Constructs a QDragEnterEvent that represents a drag entering a widget at
        the given **point** with mouse and keyboard states specified by
        **buttons** and **modifiers**.

        The drag data is passed as MIME-encoded information in **data** , and
        the specified **actions** describe the possible types of drag and drop
        operation that can be performed.

        **Warning:** Do not create a QDragEnterEvent yourself since these
        objects rely on Qt's internal state.
        """
        ...
