"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide6.QtWidgets, except for defaults which are replaced by "...".
"""
from __future__ import annotations

from enum import IntFlag

class QStyleHintReturn:
    """
    https://doc.qt.io/qt-6/qstylehintreturn.html

    **Detailed Description**

    QStyleHintReturn and its subclasses are used to pass information from a
    style back to the querying widget. This is most useful when the return value
    from **QStyle::styleHint** () does not provide enough detail; for example,
    when a mask is to be returned.
    """

    SH_Default: QStyleHintReturn.HintReturnType = ...
    SH_Mask: QStyleHintReturn.HintReturnType = ...
    SH_Variant: QStyleHintReturn.HintReturnType = ...
    Type: QStyleHintReturn.StyleOptionType = ...
    Version: QStyleHintReturn.StyleOptionVersion = ...

    class HintReturnType(IntFlag):
        SH_Default: QStyleHintReturn.HintReturnType = ...
        SH_Mask: QStyleHintReturn.HintReturnType = ...
        SH_Variant: QStyleHintReturn.HintReturnType = ...

    class StyleOptionType(IntFlag):
        Type: QStyleHintReturn.StyleOptionType = ...

    class StyleOptionVersion(IntFlag):
        Version: QStyleHintReturn.StyleOptionVersion = ...
    def __init__(self, version: int = ..., type: int = ...) -> None:
        """
        https://doc.qt.io/qt-6/qstylehintreturn.html#QStyleHintReturn

        **QStyleHintReturn::QStyleHintReturn(int version =
        QStyleOption::Version, int type = SH_Default)**

        Constructs a QStyleHintReturn with version **version** and type
        **type**.

        The version has no special meaning for QStyleHintReturn; it can be used
        by subclasses to distinguish between different version of the same hint
        type.

        **See also** **QStyleOption::version**  and **QStyleOption::type** .
        """
        ...
