"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide6.QtWidgets, except for defaults which are replaced by "...".
"""
from __future__ import annotations

from enum import IntFlag
from typing import overload

import PySide6.QtCore
import PySide6.QtGui
import PySide6.QtWidgets

class QStyleOptionProgressBar(PySide6.QtWidgets.QStyleOption):
    """
    https://doc.qt.io/qt-6/qstyleoptionprogressbar.html

    **Detailed Description**

    An instance of the QStyleOptionProgressBar class has type SO_ProgressBar and
    version 2.

    The type is used internally by **QStyleOption** , its subclasses, and
    **qstyleoption_cast** () to determine the type of style option. In general
    you do not need to worry about this unless you want to create your own
    **QStyleOption**  subclass and your own styles. The version is used by
    **QStyleOption**  subclasses to implement extensions without breaking
    compatibility. If you use **qstyleoption_cast** (), you normally do not need
    to check it.

    For performance reasons, there are few member functions and the access to
    the member variables is direct (i.e., using the `.` or `->` operator). This
    makes the structures straightforward to use and emphasizes that these are
    simply parameters used by the style functions.

    For an example demonstrating how style options can be used, see the
    **Styles**  example.

    **See also** **QStyleOption** .
    """

    Type: QStyleOptionProgressBar.StyleOptionType = ...
    Version: QStyleOptionProgressBar.StyleOptionVersion = ...

    class StyleOptionType(IntFlag):
        Type: QStyleOptionProgressBar.StyleOptionType = ...

    class StyleOptionVersion(IntFlag):
        Version: QStyleOptionProgressBar.StyleOptionVersion = ...
    @overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-6/qstyleoptionprogressbar.html#QStyleOptionProgress
        Bar

        **QStyleOptionProgressBar::QStyleOptionProgressBar()**

        Constructs a QStyleOptionProgressBar, initializing the members variables
        to their default values.
        """
        ...
    @overload
    def __init__(self, other: PySide6.QtWidgets.QStyleOptionProgressBar) -> None:
        """
        https://doc.qt.io/qt-6/qstyleoptionprogressbar.html#QStyleOptionProgress
        Bar-1

        **QStyleOptionProgressBar::QStyleOptionProgressBar(const
        QStyleOptionProgressBar & other )**

        Constructs a copy of the **other** style option.
        """
        ...
    @overload
    def __init__(self, version: int) -> None:
        """
        https://doc.qt.io/qt-6/qstyleoptionprogressbar.html#QStyleOptionProgress
        Bar

        **QStyleOptionProgressBar::QStyleOptionProgressBar()**

        Constructs a QStyleOptionProgressBar, initializing the members variables
        to their default values.
        """
        ...
